<template>
  <v-form ref="formCertificates" v-model="valid">
    <v-card>
      <v-card-title class="headline pl-5 primary white--text" primary-title>
        {{ $t('titleuploadata') }}
      </v-card-title>
      <v-divider></v-divider>
      <v-card-text class="my-3 px-5">
        <v-row class="justify-center align-center">
          <v-col cols="12" xs="12" md="10" sm="10">
            <v-tabs v-model="tab" fixed-tabs slider-color="primary">
              <v-tab :key="0" :href="'#tab-0'">
                {{ $t('uploaddata') }}
              </v-tab>
              <v-tab :key="1" :href="'#tab-1'">
                {{ $t('pastedata') }}
              </v-tab>
            </v-tabs>
          </v-col>
        </v-row>
        <v-row class="justify-center align-center">
          <v-col cols="12">
            <v-tabs-items v-model="tab">
              <v-tab-item :key="0" :value="'tab-0'">
                <client-only>
                  <FilePond
                    ref="filepondCSV"
                    max-files="1"
                    allow-multiple="false"
                    accepted-file-types="
                      text/csv,
                      application/vnd.ms-excel,
                      application/vnd.openxmlformats-officedocument.spreadsheetml.sheet
                    "
                    :label-idle="$t('uploadfile')"
                    :disabled="loading"
                    @updatefiles="updateFiles"
                  />
                </client-only>
              </v-tab-item>
              <v-tab-item :key="1" :value="'tab-1'">
                <v-col cols="12" md="12" class="mt-3 area-paste">
                  <v-textarea
                    id="excel_data"
                    v-model="pastedData"
                    solo
                    name="excel_data"
                    :placeholder="$t('textpastedata')"
                    class="pl-3 pasteData"
                  ></v-textarea>
                </v-col>
              </v-tab-item>
            </v-tabs-items>
          </v-col>
        </v-row>
      </v-card-text>
      <v-divider></v-divider>
      <v-card-actions class="px-5 my-3">
        <v-row class="justify-center align-center">
          <v-btn color="secondary" text @click="closeDialog">{{
            $t('cancel')
          }}</v-btn>
          <v-btn
            v-if="tab === 'tab-0'"
            color="primary"
            text
            :disabled="files.length === 0"
            @click="save"
          >
            {{ $t('send') }}
          </v-btn>
          <v-btn
            v-if="tab === 'tab-1'"
            color="primary"
            text
            :disabled="pastedData === ''"
            @click="parsePastedData"
          >
            {{ $t('send') }}
          </v-btn>
        </v-row>
      </v-card-actions>
    </v-card>
  </v-form>
</template>

<script lang="ts">
import Vue from 'vue'

import { mapGetters } from 'vuex'
import vueFilePond from 'vue-filepond'
import FilePondPluginFileValidateType from 'filepond-plugin-file-validate-type/dist/filepond-plugin-file-validate-type.esm.js'
import 'filepond/dist/filepond.min.css'

export default Vue.extend({
  name: 'UploadData',
  components: {
    FilePond: vueFilePond(FilePondPluginFileValidateType),
  },
  props: {},
  data: () => ({
    tab: 'tab-0',
    valid: true,
    loading: false,
    pastedData: '',
    files: [] as any,
  }),
  computed: {
    ...mapGetters({
      userStore: 'users/user',
    }),
  },
  watch: {},
  methods: {
    updateFiles(files: never[]) {
      this.files = files
    },
    parsePastedData() {
      this.$emit('paste', this.pastedData)
      this.pastedData = ''
      ;(
        this.$refs.filepondCSV as Vue & { removeFiles: () => boolean }
      ).removeFiles()
    },
    save() {
      this.$emit('save', this.files)
      this.pastedData = ''
      ;(
        this.$refs.filepondCSV as Vue & { removeFiles: () => boolean }
      ).removeFiles()
    },
    closeDialog() {
      ;(
        this.$refs.filepondCSV as Vue & { removeFiles: () => boolean }
      ).removeFiles()
      this.pastedData = ''
      this.$emit('closeDialog')
    },
  },
})
</script>
